function ueDynamicPopupButton(popupId){
  
  //objects
  var g_objPopup, g_objOverlay, g_objGridWidget, g_objTemplateItems, g_arrowNext, g_arrowPrev, g_objIframeHolder, g_objPopupButton, g_isDebugModeOn;
  
  //selectors
  var g_popupButtonSelector, g_selectorGrid;
  
  //options
  var g_isInEditor, g_showErrors, g_templateId, g_popupLink, g_popupType, g_singlePostUrl, g_isParentTemplateGridExist;
  
  //classes
  var g_activeClass, g_classPopupOpened;
  
  //index
  var g_openedPopupIndex;  
  
  /**
  * trace
  */
  function trace(val){
    
    console.log(val)
    
  }
  
  /**
  * no poopup parent grid found error handle
  */
  function disabledDynamicPopupError(){
    
    if(g_showErrors == false)
    return(false);

	if(g_popupType == 'post')
	return(false);
   
    if(g_isParentTemplateGridExist)
    return(false);
    
    var errorMessageHtml = '<div class="uc-editor-message uc-error">This button should be placed inside Dynamic Loop Template. It requires the dynamic template widget to be placed as well.</div>';
    
    //update popup html to show error message
    g_objPopup.append(errorMessageHtml);
    
  }

  /**
  * no single post found
  */
  function noSelectedPostFoundError(){
    
    if(g_showErrors == false)
    return(false);
    
    if(g_popupType != 'post')
    return(false);
    
    if(g_singlePostUrl != '')
    return(false);
    
    var errorMessageHtml = '<div class="uc-editor-message uc-error">Dynamic Popup Button Widget Error: Please Choose a Post for Popup.</div>';
    
    //update popup html to show error message
    g_objPopup.append(errorMessageHtml);
    
  }
  
  /**
  * click on trigger element
  */
  function onFoundElement(){
    
    if(g_popupType != 'template')
    return(false);
    
    if(g_isInEditor == 'yes')
    return(false);    
            
    if(!g_isParentTemplateGridExist)
    return(false);
    
    var successMessageHtml = '<div class="uc-editor-message uc-success">Dynamic Popup Button Connected To Template.</div> ';
    
    //update popup html to show success message
    g_objIframeHolder.append(successMessageHtml);
    
  }
  
  /**
  * debug popup for styling  
  */
  function debugPopup(){
    
    if(g_isInEditor == 'no')
    return(false);
    
    if(g_isDebugModeOn == false)
    return(false);
    
    if(g_popupLink == '' && g_popupType == 'template')
    return(false);

    if(g_singlePostUrl == '' && g_popupType == 'post')
    return(false);
    
    createIframe();
    
  }
  
  /*
  * find parent widget popup links to navigate through parent widget posts
  */
  function findParentWidgetPopupLinks(){
    
    if(g_popupType != 'template')
    return(false);
    
    //find all popup buttons
    var parentWidgetPopupLinks = g_objGridWidget.find(g_popupButtonSelector); 
    
    //find opened popup index
    parentWidgetPopupLinks.each(function(index, link){
      
      var objLink = jQuery(this);
      
      //set data num attribute for popup links navigation
      objLink.attr('data-dynamic-popup-num', index);

    });
    
  }
  
  /*
  * get popup link
  */
  function getPopupLink(){
    
    var popupLink;
    
    //find post link
    popupLink = g_objPopupButton.attr("href");
    
    //if debug is on and is in editor then use custom post link
    if(g_isDebugModeOn == true && g_isInEditor == 'yes' && g_popupType == 'template')
    popupLink = g_popupLink;
    
    return(popupLink);
    
  }
  
  /*
  * create iframe and place it inside popup widget
  */
  function createIframe(){
    
    objLoader = g_objPopup.find('.ue-loader-text');
    
    //show loader
    objLoader.show();
    
    var iframeBaseSrc = getPopupLink();
    
    //create html for iframe
    var iframeHtml = '<iframe class="uc-iframe" src="' + iframeBaseSrc + '?ucrendertemplate='+g_templateId+'" frameborder="0" ></iframe>';
    
    //find iframe holder and put iframe html      
    g_objIframeHolder.html(iframeHtml);    
    
    //add active class to overlay
    g_objOverlay.addClass(g_activeClass); 
    
    var objIframe = g_objPopup.find("iframe");      
    
    //wait while iframe is loaded
    objIframe.load(function(){      
      
      //hide loader
      objLoader.hide();
      
      //find header and footer in iframe and remove them            
      var objIframeHeader = objIframe.contents().find("header");
      var objIframeFooter = objIframe.contents().find("footer");
      
      //remove header and footer from iframe
      if(objIframeHeader.length)
      objIframeHeader.remove();
      
      if(objIframeFooter.length)
      objIframeFooter.remove();       
      
    });
    
  }
  
  /**
  * click on trigger element
  */
  function onOpenPopupClick(e){  
    
    e.preventDefault();
    
    var objPopupButton = jQuery(this);
    
    //if popup is opened then do not open it again
    if(g_objOverlay.hasClass(g_activeClass) == true)
    return(false);
    
    //remove animation fill mode property from parent item (position fixed bug)
    if(g_objTemplateItems.length)
    g_objTemplateItems.css('animation-fill-mode', 'none');
    
    onFoundElement();
    
    //dont run in editor
    if(g_isInEditor == 'yes')
    return(true);
    
    g_objOverlay.addClass(g_activeClass);   
    
    //remove active class from other buttons
    g_objPopupButton.removeClass(g_activeClass);
    
    //add active class to current button
    objPopupButton.addClass(g_activeClass);
    
    //for navigation between posts
    findParentWidgetPopupLinks();    

    //find popup index
    g_openedPopupIndex = objPopupButton.data('dynamic-popup-num');
    
    //add class to body to hide scroll
    jQuery('body').addClass(g_classPopupOpened);
    
    //create iframe
    createIframe();
    
  }
  
  /**
  * click on close element
  */
  function onClosePopupClick(){
    
    //dont run in editor
    if(g_isInEditor == 'yes')
    return(false);
    
    clearPopup();
    
  }
  
  /*
  * clear popup (not working in editor)
  */
  function clearPopup(){
    
    if(g_isDebugModeOn == true && g_isInEditor == 'yes')
    return(false);
    
    g_objOverlay.removeClass(g_activeClass);
    
    jQuery('body').removeClass(g_classPopupOpened);
    
  }
  
  /*
  * click on arrow right
  */
  function onArrowNextClick(){
    
    if(!g_objTemplateItems)
    return(false);
    
    //if g_openedPopupIndex >= items amount reset g_openedPopupIndex
    var itesmAmount = g_objTemplateItems.length;
    
    g_openedPopupIndex++;
    
    if(g_openedPopupIndex >= itesmAmount)
    g_openedPopupIndex = 0;      
    
    var objNextParentPopupLink = g_objGridWidget.find('[data-dynamic-popup-num="'+g_openedPopupIndex+'"]');
    clearPopup();
    
    objNextParentPopupLink.trigger('click');
    
  }
  
  /*
  * click on arrow left
  */
  function onArrowPrevClick(){
    
    if(!g_objTemplateItems)
    return(false);
    
    var itesmAmount = g_objTemplateItems.length;
    
    if(g_openedPopupIndex == 0)
    g_openedPopupIndex = itesmAmount;
    
    g_openedPopupIndex--;
    
    var objPrevParentPopupLink = g_objGridWidget.find('[data-dynamic-popup-num="'+g_openedPopupIndex+'"]');
    clearPopup();
    
    objPrevParentPopupLink.trigger('click');
    
  }
  
  //enable popup links after js load for template button type
  function enableTemplatePopupLink(){
    
    if(g_popupType != 'template')
    return(false);
                  
    if(!g_isParentTemplateGridExist)
    return(false);
    
    var itemsNum = g_objTemplateItems.length;
    
    for(let i=0; i<itemsNum; i++){      
      
      var objItem = g_objTemplateItems.eq(i);
      var dataLink = objItem.data('template-link');
      var objLink = objItem.find(g_popupButtonSelector); 	
      
      objLink.attr("href", dataLink); 
      
    } 
    
  }
  
  //enable popup links after js load for post button type
  function enablePostPopupLink(){
    
    if(g_popupType != 'post')
    return(false);    
        
    g_objPopupButton.attr('href', g_singlePostUrl);
    
  }
  
  function initPopup(){
    
    g_popupButtonSelector = '.ue-dynamic-popup-trigger';
    
    //init vars
    //objects
    g_objPopup = jQuery('#'+popupId);
    g_objPopupButton = g_objPopup.find(g_popupButtonSelector);
    g_objOverlay = g_objPopup.find('.ue-dynamic-popup-overlay');
    g_objIframeHolder = g_objPopup.find('.ue-dynamic-popup-iframe-holder');    
    g_arrowNext = g_objPopup.find('.ue-dynamic-popup-next-arrow');
    g_arrowPrev = g_objPopup.find('.ue-dynamic-popup-prev-arrow');
    
    //attributes
    g_isInEditor = g_objPopup.data('editor');
    g_showErrors = g_objPopup.data('show-errors');
    g_source = g_objPopup.data('source');
    g_isDebugModeOn = g_objIframeHolder.data('debug');
    g_templateId = g_objPopup.data('template');
    g_popupLink = g_objIframeHolder.data('debug-post');
    g_popupType = g_objPopup.data('popup-type');
    g_singlePostUrl = g_objPopup.data("single-post");

    //classes
    g_activeClass = 'uc-active';
    g_classPopupOpened = "ue-popup-opened";    
    
    //selectors
    g_selectorPopup = '.ue-dynamic-popup-button-wrap';
    g_selectorGrid = '.ue-dynamic-popup-button-grid';
                             
    //boolean
    g_isParentTemplateGridExist = g_objPopup.parents(g_selectorGrid).length;
    
    //parent grid widget
    g_objGridWidget = g_objPopup.parents(g_selectorGrid); 
    
    //parent grid items
    g_objTemplateItems = g_objGridWidget.children();  
    
    //if in front and template grid doesn`t exist show error   
    disabledDynamicPopupError(); 

    //if in editor and no post found show error   
    noSelectedPostFoundError();
    
    //add href attributes to popup button links for template type
    enableTemplatePopupLink();

    //add href attributes to popup button links for post type
    enablePostPopupLink()
    
    //init events
    var dataShowArrows = g_objPopup.data('show-arrows');
    
    if(dataShowArrows == true && g_popupType == 'template'){          
      
      g_arrowNext.on('click', onArrowNextClick);
      g_arrowPrev.on('click', onArrowPrevClick);
      
    }    
    
    g_objPopupButton.on('click', onOpenPopupClick);    
    
    var objClosePopup = g_objPopup.find('.ue-dynamic-popup-close');

    //fix z-index for close button
    objClosePopup.css('z-index', 100);
    
    objClosePopup.on('click', onClosePopupClick);
    
    g_objOverlay.on("click", function(event){
      
      var navArrow = g_objPopup.find('.ue-dynamic-popup-arrow');
      
      if (jQuery(event.target).closest(navArrow).length)
      return(true);
      
      //close popup unless target isn`t popup wrap object (not working in debug mode in editor)
      if (!jQuery(event.target).closest(g_objIframeHolder).length)
      onClosePopupClick();
      
    });
    
    //show message if no template found
    if(g_isInEditor == "yes"){
      
      if(g_templateId == '')
      g_objPopup.append("<div class='uc-editor-message'>Please choose a template.</div>");
      
      debugPopup();
      
    } 
    
  }
  
  initPopup();
  
}